// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.internal.component.AbstractUIScript;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/**
 This tag adds script files to include into the rendered page.
  <br>
  Some features are deprecated (because of CSP): This tag adds client side script to the rendered page.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ScriptTagDeclaration}.
 */
@Generated("component.stg")
public class UIScript
    extends AbstractUIScript  {

  private static final Tags TAG = Tags.script;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.Script";


  enum PropertyKeys {
    file,
    type,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  File name to include into the rendered page. The name must be full qualified, or relative.
   If using a complete path from root, you'll need to add the contextPath from the web application.
   This can be done with the EL #{request.contextPath}.

  */
  public java.lang.String getFile() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.file);
  }

  public void setFile(java.lang.String file) {
    getStateHelper().put(PropertyKeys.file, file);
  }

  /**
  Type of the script.
  <br>Default: <code>text/javascript</code>
  */
  public java.lang.String getType() {
    java.lang.String type = (java.lang.String) getStateHelper().eval(PropertyKeys.type);
    if (type != null) {
      return type;
    }
    return "text/javascript";
  }

  public void setType(java.lang.String type) {
    getStateHelper().put(PropertyKeys.type, type);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}